'  61 : 6100/1024*256=1525
'  60 : 6000/1024*256=1500
'  50 : 5000/1024*256=1250 
'  37 : 3700/1024*256=925 
'  35 : 3500/1024*256=875  
'  10 : 1000/1024*256=250  
'  20 : 2000/1024*256=500
'  21 : 2100/1024*256=525
'  2  : 200/1024*256=50
'  1  : 100/1024*256=25
''''============================================       
''    PRINT AT 1,1, "U=",DEC4 V," I=",DEC4 A
''    PRINT AT 2,1, "U",DEC2 V//100," I",DEC2 A//100
''     q = V * A
''     q=DIV32 1000
''    PRINT " P", DEC,q
''''========= =============================    

DEVICE 16F876
DECLARE XTAL 4          'OSC = 4   	 
OPTION_REG.7 = 0        '   PortB
TRISA=%00000111 
TRISB=%11110000
TRISC=%00000000
ADCON1=%10000010
PORTC=0                 '0  PORTC,   .   

SYMBOL  Protect=PORTC.3     '       
SYMBOL  LedV=PORTC.1        '  HL1
SYMBOL  LedA=PORTC.2        '  HL2
SYMBOL  Beep=PORTC.0        '       
SYMBOL  SetButton=PORTB.7   '  
SYMBOL  SbrosButton=PORTB.6 '     .

SYMBOL  JumpA=PORTB.5  ':        <LedA>
                            '  -     
                            ' -     
                            
SYMBOL  JumpV=PORTB.4  ':        <LedV>
                            '  -     
                            ' -     
SYMBOL  KorBit=PORTC.5  '    .
                            
LedV=JumpV    '   LedV
LedA=JumpA    '   LedA
KorBit=0

DECLARE ADIN_RES 10     '    (16F876  10-  ) 
DECLARE ADIN_STIME 50   '    : 50 (uS)
DECLARE LCD_TYPE 0          ' LCD: 0 - -
DECLARE LCD_DTPIN PORTB.0   'D4  PORTB.0                  
DECLARE LCD_ENPIN PORTC.7   'E   PORTC.7
DECLARE LCD_RSPIN PORTC.6   'RS  PORTC.6
DECLARE LCD_INTERFACE 4     '4-    LCD
DECLARE LCD_COMMANDUS 5000  '  ()
DECLARE LCD_DATAUS 50       '    
DECLARE LCD_LINES 2         '2-    LCD

'DELAYMS 100
CLS
'PRINT $FE,2 
PRINT $FE,$40,  $15, $15, $15, $15, $15, $15, $1F, $01      '(0)
PRINT $FE,$48,  $11, $11, $13, $15, $19, $11, $11, $00      '(1)
PRINT $FE,$50,  $1F, $11, $11, $11, $11, $11, $11, $00      '(2)
PRINT $FE,$58,  $15, $15, $15, $0E, $15, $15, $15, $00      '(3)
PRINT $FE,$60,  $11, $11, $11, $0F, $01, $01, $01, $00      '(4)
PRINT $FE,$68,  $1F, $11, $10, $1E, $11, $11, $1E, $00      '(5)
PRINT $FE,$70,  $11, $11, $11, $19, $15, $15, $19, $00      '(6)
PRINT $FE,$78,  $11, $11, $11, $0A, $04, $08, $10, $00      '(7)

DIM adcV    AS  WORD    '   0...1023
DIM adcA    AS  WORD    '   0...1023
DIM jv1     AS  BIT
DIM ja1     AS  BIT                           
DIM sbros   AS  BIT     '  .    : 
                        '1 -   4      , 
                        '0-  <SbrosButton>

DIM LongPress   AS 20   '   
DIM ButtonPress AS BYTE	'-     
DIM q       AS  WORD    '-
DIM Vc      AS  WORD    '3500/1024*256=875  
DIM Ac      AS  WORD    '1000/1024*256=250  
DIM Uover   AS  WORD    '    
DIM Iover   AS  WORD    '    
DIM Uz      AS  BYTE    'U 
DIM Iz      AS  BYTE    'I 
DIM Akor    AS  BYTE    '     ..   LM358 
                        '     
DIM Vmax    AS  BYTE
DIM Amax    AS  BYTE
DIM k       AS  BYTE    '     <SetButton>
DIM g       AS  25      ' -
DIM CurX    AS  8       '      <Vmax>  <Amax>
DIM V       AS  WORD    '  3500  
DIM A       AS  WORD    '  1000  
DIM mA      AS  BYTE    '   
DIM adcR    AS  BYTE    '       0...1023
DIM Freq1   AS  BYTE    ' 1  2   
DIM Freq2   AS  BYTE
DIM ev      AS  BYTE    '  =  >  U=xxB
DIM ea      AS  BYTE    '  =  >  I=xxA
DIM i       AS  BYTE    '  (4max=4)    ""
DIM CyclePause  AS WORD '      
jv1=JumpV+1             '     
ja1=JumpA+1

'   EEPROM
Vc=EREAD 0
Ac=EREAD 2
Akor=EREAD 4    '   I=0              
sbros=EREAD 5
Uz=EREAD 6
Iz=EREAD 7

Vmax=Vc/g               '4/100
Amax=Ac/g               '4/100

IF Vc>1525  THEN Vc=875
IF Ac>525   THEN Ac=250
IF Uz>Vmax THEN Uz=Vmax
IF Iz>Amax THEN Iz=Amax
Uover=Uz * 100
Iover=Iz * 100
k=0
CyclePause=0
ev=61
ea=ev

main: 
    INCLUDE "SetButton.inc"
    i=0
    
more: 
    '     0...1023  
    adcV=ADIN 0
    adcA=ADIN 1
    adcR=ADIN 2

alarm:
    IF adcV = 0 THEN
        V=0
        Akor=adcA 
    ELSE 
        q=(adcV+1)*10*/Vc '10240*875/256=35000; 10230*875/256=34965.82; 10220*875/256=34931.64
        V=q/10
        IF q//10 >= 5 THEN INC V    '   
    ENDIF
    V = V - (adcR >> 1)
    IF adcA > Akor THEN 
        q=(adcA+1)*10*/Ac
        A=q/10
        IF q//10 >= 5 THEN INC A
    ELSE 
        A=0 
    ENDIF
    PRINT AT 1,1,"U",ev,DEC V/100,".",DEC2 V//100,"B I",ea,DEC A/100,"."
    mA=A//100   ' 1739//100=39 -    
    IF A < 1000 THEN
        PRINT DEC2 mA
    ELSE
        q=mA//10
        IF q < 5 THEN 
            PRINT DEC1 mA/10
        ELSE
            PRINT DEC1 mA/10 + 1
        ENDIF               
    ENDIF
    PRINT "A  "        
    CURSOR 2,1
    IF sbros=0 THEN 
        PRINT "*"
    ELSE
        PRINT " "
    ENDIF
    q = V * A
    q = DIV32 1000  
    PRINT " Pa = ",DEC q/10,".",DEC1 q//10," BA",REP 32\3
    CURSOR 2,16

    IF V>=Uover THEN
        LedV=JumpV
        Protect=0
        ev=62
        GOSUB lcdz
        PRINT " HA",2,"P."
        CURSOR 1,1
        Freq1=105
        Freq2=106
        GOSUB zvuk
    ELSE
        LedV=jv1    'JumpV+1
        ev=61
        IF A>=Iover THEN
            LedA=JumpA
            Protect=0
            ea=62
            GOSUB lcdz
            PRINT " TOK",7," "
            CURSOR 1,9
            Freq1=112
            Freq2=110
            GOSUB zvuk
        ELSE
            LedA=ja1    'JumpA+1
            Protect=1
            CyclePause=0
            ea=61
            i=3
        ENDIF
    ENDIF
    
    DELAYMS CyclePause
    
    IF Protect=0 THEN
        IF sbros=0 THEN
            i=3
            IF SbrosButton=1 THEN GOTO alarm
        ENDIF
    ENDIF
    
    IF i<3 THEN
        INC i
        GOTO alarm
    ENDIF           
    IF KorBit=0 THEN EWRITE 4,[Akor]    ' Akor  EEPROM    0
    KorBit=1    ' 1,      EEPROM    
GOTO main       '  

'''------------------ :--------------------------
zvuk:
    DELAYMS CyclePause  '1000
    PRINT REP 32\8            
    SOUND Beep,[Freq1,10,Freq2,10]
    Beep=0
RETURN

lcdz:
    CyclePause=1000
    PRINT AT 2,2,"3A",0,1,"TA ",2,"O" 
RETURN

kak_sbros:
    CURSOR 2,1
    IF sbros=0 THEN
        PRINT "HA",3,"AT",1,"EM KHO",2,"K",1,32
    ELSE
        PRINT "ABTOMAT",1,4,"ECK",1,REP 32\3
    ENDIF
    CURSOR 2,1
RETURN

uiz:
    PRINT AT 1,1, "CPA",5,"AT",6,"B. 3A",0,1,"T",6   
    PRINT AT 2,1, 2,"P",1,": U=",DEC2 Uz,"B I=",DEC2 Iz,"A"
RETURN    

uimax:
    PRINT AT 1,1,"Umax = ",DEC2 Vmax," B",REP 32\5
    PRINT AT 2,1,"Imax = ",DEC2 Amax," A",REP 32\5
RETURN            
                        
END 

